tests: strict order on tests.sh
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export NIT_TESTING=true
23
24 unset NIT_DIR
25
26 usage()
27 {
28 e=`basename "$0"`
29 cat<<END
30 Usage: $e [options] modulenames
31 -o option Pass option to the engine
32 -v Verbose (show tests steps)
33 -h This help
34 --tap Produce TAP output
35 --engine Use a specific engine (default=nitc)
36 --noskip Do not skip a test even if the .skip file matches
37 --[no]soso Force enable (or disable) SOSO
38 END
39 }
40
41 # $1 is the pattern of the test
42 # $2 is the file to compare to
43 # the result is:
44 # 0: if the file to compare to do not exists
45 # 1: if the file match
46 # 2: if the file match with soso
47 # 3: if the file do not match
48 function compare_to_result()
49 {
50 local pattern="$1"
51 local sav="$2"
52 if [ ! -r "$sav" ]; then return 0; fi
53 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
54 if [ "$?" == 0 ]; then
55 return 1
56 fi
57 [ -z "$soso" ] && return 3
58 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
59 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
60 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
61 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
62 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
63 if [ "$?" == 0 ]; then
64 return 2
65 else
66 return 3
67 fi
68 }
69
70 # As argument: the pattern used for the file
71 function process_result()
72 {
73 ((tapcount=tapcount+1))
74 # Result
75 pattern=$1
76 description=$2
77 pack=$3
78 SAV=""
79 NSAV=""
80 FIXME=""
81 NFIXME=""
82 SOSO=""
83 NSOSO=""
84 SOSOF=""
85 NSOSOF=""
86 OLD=""
87 LIST=""
88 FIRST=""
89 echo >>$xml "<testcase classname='$pack' name='$description'>"
90 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
91 for savdir in $savdirs; do
92 sav=$savdir/$pattern.res
93 compare_to_result "$pattern" "$sav"
94
95 case "$? $sav" in
96 0*)
97 continue;; # no file
98 1*/fixme/*)
99 OLD="$LIST"
100 FIXME="$sav"
101 ;;
102 1*)
103 OLD="$LIST"
104 SAV="$sav"
105 ;;
106 2*/fixme/*)
107 SOSOF="$sav" ;;
108 2*)
109 SOSO="$sav" ;;
110 3*/fixme/*)
111 if [ -z "$FIRST" ]; then
112 NFIXME="$sav"
113 FIRST="$sav"
114 fi
115 ;;
116 3*)
117 if [ -z "$FIRST" ]; then
118 NSAV="$sav"
119 FIRST="$sav"
120 fi
121 ;;
122 esac
123 LIST="$LIST $sav"
124 done
125 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
126 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
127 NYI="$?"
128 if [ -n "$SAV" ]; then
129 if [ -n "$tap" ]; then
130 echo "ok - $description"
131 elif [ -n "$OLD" ]; then
132 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
133 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
134 remains="$remains $OLD"
135 else
136 echo "[ok] out/$pattern.res $SAV"
137 fi
138 ok="$ok $pattern"
139 elif [ -n "$FIXME" ]; then
140 if [ -n "$tap" ]; then
141 echo "not ok - $description # TODO expected failure"
142 elif [ -n "$OLD" ]; then
143 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
144 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
145 remains="$remains $OLD"
146 else
147 echo "[fixme] out/$pattern.res $FIXME"
148 fi
149 todos="$todos $pattern"
150 elif [ -n "$SOSO" ]; then
151 if [ -n "$tap" ]; then
152 echo "ok - $description # SOSO"
153 else
154 echo "[soso] out/$pattern.res $SOSO"
155 fi
156 ok="$ok $pattern"
157 elif [ "x$NYI" = "x0" ]; then
158 if [ -n "$tap" ]; then
159 echo "not ok - $description # TODO not yet implemented"
160 else
161 echo "[todo] out/$pattern.res -> not yet implemented"
162 fi
163 todos="$todos $pattern"
164 elif [ -n "$SOSOF" ]; then
165 if [ -n "$tap" ]; then
166 echo "not ok - $description # TODO SOSO expected failure"
167 else
168 echo "[fixme soso] out/$pattern.res $SOSOF"
169 fi
170 todos="$todos $pattern"
171 elif [ -n "$NSAV" ]; then
172 if [ -n "$tap" ]; then
173 echo "not ok - $description"
174 else
175 echo "[======= fail out/$pattern.res $NSAV =======]"
176 fi
177 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
178 echo >>$xml "<system-out><![CDATA["
179 head >>$xml -n 50 out/$pattern.diff.sav.log
180 echo >>$xml "]]></system-out>"
181 nok="$nok $pattern"
182 echo "$ii" >> "$ERRLIST"
183 elif [ -n "$NFIXME" ]; then
184 if [ -n "$tap" ]; then
185 echo "not ok - $description"
186 else
187 echo "[======= changed out/$pattern.res $NFIXME ======]"
188 fi
189 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
190 echo >>$xml "<system-out><![CDATA["
191 head >>$xml -n 50 out/$pattern.diff.sav.log
192 echo >>$xml "]]></system-out>"
193 nok="$nok $pattern"
194 echo "$ii" >> "$ERRLIST"
195 else
196 if [ -n "$tap" ]; then
197 echo "ok - $description # skip no sav"
198 else
199 echo "[=== no sav ===] out/$pattern.res"
200 fi
201 echo >>$xml "<skipped/>"
202 echo >>$xml "<system-out><![CDATA["
203 cat >>$xml out/$pattern.res
204 echo >>$xml "]]></system-out>"
205 nos="$nos $pattern"
206 fi
207 if test -s out/$pattern.cmp.err; then
208 echo >>$xml "<system-err><![CDATA["
209 cat >>$xml out/$pattern.cmp.err
210 echo >>$xml "]]></system-err>"
211 fi
212 echo >>$xml "</testcase>"
213 }
214
215 need_skip()
216 {
217 test "$noskip" = true && return 1
218 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
219 ((tapcount=tapcount+1))
220 if [ -n "$tap" ]; then
221 echo "ok - $2 # skip"
222 else
223 echo "=> $2: [skip]"
224 fi
225 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
226 return 0
227 fi
228 return 1
229 }
230
231 find_nitc()
232 {
233 ((tapcount=tapcount+1))
234 name="$enginebinname"
235 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
236 if [[ "x$recent" == "x" ]]; then
237 if [ -n "$tap" ]; then
238 echo "not ok - find binary for $engine"
239 echo "Bail out! Could not find binary for engine $engine, aborting"
240 else
241 echo "Could not find binary for engine $engine, aborting"
242 fi
243 exit 1
244 fi
245 if [ -n "$tap" ]; then
246 echo "ok - find binary for $engine: $recent $OPT"
247 else
248 echo "Find binary for engine $engine: $recent $OPT"
249 fi
250 NITC=$recent
251 }
252
253 verbose=false
254 stop=false
255 tapcount=0
256 engine=nitc
257 noskip=
258 while [ $stop = false ]; do
259 case $1 in
260 -o) OPT="$OPT $2"; shift; shift;;
261 -v) verbose=true; shift;;
262 -h) usage; exit;;
263 --tap) tap=true; shift;;
264 --engine) engine="$2"; shift; shift;;
265 --noskip) noskip=true; shift;;
266 --soso) soso=true; shift;;
267 --nososo) nososo=true; shift;;
268 *) stop=true
269 esac
270 done
271 enginebinname=$engine
272 case $engine in
273 nitc)
274 savdirs="sav/$engine/fixme/ sav/$engine/ sav/sav/ sav/"
275 ;;
276 nitg)
277 engine=nitg-s;
278 enginebinname=nitg;
279 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
280 OPT="--separate $OPT"
281 ;;
282 nitg-s)
283 enginebinname=nitg;
284 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
285 OPT="--separate $OPT"
286 ;;
287 nitg-e)
288 enginebinname=nitg;
289 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
290 OPT="--erasure $OPT"
291 ;;
292 nitg-g)
293 enginebinname=nitg;
294 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
295 OPT="--global $OPT"
296 ;;
297 nit)
298 engine=niti
299 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
300 ;;
301 niti)
302 enginebinname=nit
303 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
304 ;;
305 esac
306
307 # The default nitc compiler
308 [ -z "$NITC" ] && find_nitc
309
310 # Set NIT_DIR if needed
311 [ -z "$NIT_DIR" ] && export NIT_DIR=..
312
313 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
314 TIMEOUT="timelimit -t 600"
315 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
316 TIMEOUT="timeout 600s"
317 else
318 echo "No timelimit or timeout command detected. Tests may hang :("
319 fi
320
321 # Mark to distinguish files among tests
322 # MARK=
323
324 # File where error tests are outputed
325 # Old ERRLIST is backuped
326 ERRLIST=${ERRLIST:-errlist}
327 ERRLIST_TARGET=$ERRLIST
328
329 if [ $# = 0 ]; then
330 usage;
331 exit
332 fi
333
334 # Initiate new ERRLIST
335 if [ "x$ERRLIST" = "x" ]; then
336 ERRLIST=/dev=null
337 else
338 ERRLIST=$ERRLIST.tmp
339 > "$ERRLIST"
340 fi
341
342 ok=""
343 nok=""
344 todos=""
345 xml="tests-$engine.xml"
346 echo >$xml "<testsuites><testsuite>"
347
348 # CLEAN the out directory
349 rm -rf out/ 2>/dev/null
350 mkdir out 2>/dev/null
351
352 for ii in "$@"; do
353 if [ ! -f $ii ]; then
354 echo "File '$ii' does not exist."
355 continue
356 fi
357 f=`basename "$ii" .nit`
358
359 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
360
361 # Sould we skip the file for this engine?
362 need_skip $f $f $pack && continue
363
364 tmp=${ii/../AA}
365 if [ "x$tmp" = "x$ii" ]; then
366 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
367 else
368 includes="-I alt"
369 fi
370
371 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
372 bf=`basename $i .nit`
373 ff="out/$bf"
374
375 # Sould we skip the alternative for this engine?
376 need_skip $bf $bf $pack && continue
377
378 test -z "$tap" && echo -n "=> $bf: "
379
380 if [ -f "$f.inputs" ]; then
381 inputs="$f.inputs"
382 else
383 inputs=/dev/null
384 fi
385
386 if [ "$engine" = "niti" ]; then
387 cat > "./$ff.bin" <<END
388 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
389 END
390 chmod +x "./$ff.bin"
391 > "$ff.cmp.err"
392 > "$ff.compile.log"
393 ERR=0
394 else
395 # Compile
396 if [ "x$verbose" = "xtrue" ]; then
397 echo ""
398 echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
399 fi
400 NIT_NO_STACK=1 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
401 ERR=$?
402 if [ "x$verbose" = "xtrue" ]; then
403 cat "$ff.compile.log"
404 cat >&2 "$ff.cmp.err"
405 fi
406 fi
407 if [ "$ERR" != 0 ]; then
408 test -z "$tap" && echo -n "! "
409 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
410 process_result $bf $bf $pack
411 elif [ -x "./$ff.bin" ]; then
412 test -z "$tap" && echo -n ". "
413 # Execute
414 args=""
415 if [ "x$verbose" = "xtrue" ]; then
416 echo ""
417 echo "NIT_NO_STACK=1 ./$ff.bin" $args
418 fi
419 NIT_NO_STACK=1 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
420 if [ "x$verbose" = "xtrue" ]; then
421 cat "$ff.res"
422 cat >&2 "$ff.err"
423 fi
424 if [ -f "$ff.write" ]; then
425 cat "$ff.write" >> "$ff.res"
426 elif [ -d "$ff.write" ]; then
427 LANG=C /bin/ls -F $ff.write >> "$ff.res"
428 fi
429 cp "$ff.res" "$ff.res2"
430 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
431 process_result $bf $bf $pack
432
433 if [ -f "$f.args" ]; then
434 fargs=$f.args
435 cptr=0
436 while read line; do
437 ((cptr=cptr+1))
438 args="$line"
439 bff=$bf"_args"$cptr
440 fff=$ff"_args"$cptr
441 name="$bf args $cptr"
442
443 # Sould we skip the input for this engine?
444 need_skip $bff " $name" $pack && continue
445
446 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
447 if [ "x$verbose" = "xtrue" ]; then
448 echo ""
449 echo "NIT_NO_STACK=1 ./$ff.bin" $args
450 fi
451 test -z "$tap" && echo -n "==> $name "
452 echo "./$ff.bin $args" > "./$fff.bin"
453 chmod +x "./$fff.bin"
454 sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $inputs > $fff.res 2>$fff.err"
455 if [ "x$verbose" = "xtrue" ]; then
456 cat "$fff.res"
457 cat >&2 "$fff.err"
458 fi
459 if [ -f "$fff.write" ]; then
460 cat "$fff.write" >> "$fff.res"
461 elif [ -d "$fff.write" ]; then
462 LANG=C /bin/ls -F $fff.write >> "$fff.res"
463 fi
464 if [ -s "$fff.err" ]; then
465 cp "$fff.res" "$fff.res2"
466 cat "$fff.err" "$fff.res2" > "$fff.res"
467 fi
468 process_result $bff " $name" $pack
469 done < $fargs
470 fi
471 else
472 test -z "$tap" && echo -n "! "
473 cat "$ff.cmp.err" > "$ff.res"
474 echo "Compilation error" > "$ff.res"
475 process_result $bf "$bf" $pack
476 fi
477 done
478 done
479
480 if [ -n "$tap" ]; then
481 echo "1..$tapcount"
482 echo "# ok:" `echo $ok | wc -w`
483 echo "# not ok:" `echo $nok | wc -w`
484 echo "# no sav:" `echo $nos | wc -w`
485 echo "# todo/fixme:" `echo $todos | wc -w`
486 echo "# of sav that remains:" `echo $remains | wc -w`
487 exit
488 fi
489
490 echo "engine: $engine ($enginebinname $OPT)"
491 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
492
493 if [ -n "$nok" ]; then
494 echo "fail: $nok"
495 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
496 fi
497 if [ -n "$nos" ]; then
498 echo "no sav: $nos"
499 fi
500 if [ -n "$todos" ]; then
501 echo "todo/fixme: $todos"
502 fi
503 if [ -n "$remains" ]; then
504 echo "sav that remains: $remains"
505 fi
506
507 # write $ERRLIST
508 if [ "x$ERRLIST" != "x" ]; then
509 if [ -x "$ERRLIST_TARGET" ]; then
510 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
511 fi
512 mv $ERRLIST $ERRLIST_TARGET
513 fi
514
515 echo >>$xml "</testsuite></testsuites>"
516
517 if [ -n "$nok" ]; then
518 exit 1
519 else
520 exit 0
521 fi